## Créé le 5/9/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

##
# Mise à jour graphique des étiquettes
##
proc Katyusha_Etiquettes_maj {} {
    global etiquettes
    global etiquettes_graphique
    foreach {id etiquette} $etiquettes {
        #set ID $id
        set graph [Katyusha_Etiquettes_creer_affichage_graphique $id $etiquette]
        # Ajoute la liste temporaire au dictionnaire graphique des étiquettes
        dict set etiquettes_graphique $id $graph
        puts "Ajout de l'étiquette : [dict get $etiquette nom]"
        unset graph id etiquette
        # Met à jour l'arbre des entités
        maj_arbre_entites
    }
}

##
# Ajoute une étiquette
##
proc Katyusha_Etiquettes_ajout_etiquette {etiquette_tmp} {
    # Charge la variable globale contenant toutes les etiquettes
    global etiquettes
    global etiquettes_graphique
    global ID
    # Créé un id pour la nouvelle table
    set id [expr [dict size $etiquettes]]
    # Ajoute la nouvelle table aux etiquettes existantes
    dict set etiquettes $ID $etiquette_tmp
    set graph [Katyusha_Etiquettes_creer_affichage_graphique $ID $etiquette_tmp]
    # Ajoute la liste temporaire au dictionnaire graphique des etiquettes
    dict set etiquettes_graphique $ID $graph
    puts "Ajout de l'étiquette : [dict get $etiquette_tmp nom]"
    set ID [expr $ID + 1]
    #unset graph id
    # Met à jour l'arbre des entités
    maj_arbre_entites
}

proc Katyusha_Etiquettes_creer_affichage_graphique {ID etiquette} {
    # Récupère le nom de l'étiquette
    set nom [dict get $etiquette "nom"]
    set texte [dict get $etiquette "texte"]
    set hauteur 200
    # Calcul la taille de l'étiquette sur le canvas
    set largeur [expr 50 + 50]
    # Créé l'affichage graphique de la nouvelle étiquette dans une liste temporaire
    set x [lindex [dict get $etiquette "coords"] 0]
    set y [lindex [dict get $etiquette "coords"] 1]
    lappend graph [.mcd.canvas.c create rect [expr $x - [expr $largeur / 2]] [expr $y - 80] [expr $x + [expr $largeur / 2]] [expr $y - 40] -outline #FF7000 -fill #FFE3CD -tag [list etiquette $ID]]
    lappend graph [.mcd.canvas.c create text [expr $x + 0] [expr $y - 60] -fill black -anchor w -justify center -text $texte -tag [list etiquette $ID]]
    return $graph
}

##
# Mis à jour des coordonnées de l'étiquette passée en paramètre
##
proc Katyusha_Etiquettes_MAJ_coords {id_etiquette coords} {
    global etiquettes
    set etiquette [dict get $etiquettes $id_etiquette]
    dict set etiquette "coords" $coords
    dict set etiquettes $id_etiquette $etiquette
}

proc Etiquettes_supression_etiquette {etiquette} {
    global LOCALE
    global etiquettes
    global etiquettes_graphique
    # Récupère le nom de l'étiquette
    set nom [dict get [dict get $etiquettes $etiquette] nom]
    # Supprime l'étiquette du tableau général
    dict unset etiquettes $etiquette
    # Supprime l'affichage de l'étiquette
    for {set c 0} {$c < 2} {incr c} {
        .mcd.canvas.c delete [lindex [dict get $etiquettes_graphique $etiquette] $c]
    }
    dict unset etiquettes_graphique $etiquette
    maj_arbre_entites
    puts "Étiquette $nom supprimée"
    unset nom
}
