## Créé le 5/6/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

proc Katyusha_SQL_liste_types {} {
    set types [list "integer" "smallint" "bigint" "serial" "bigserial" "text" "char" "varchar" "date" "double" "float" "real" "bool" "boolean" "time" "timetz" "timestamp" "timestamptz"]
    return $types
}

proc Katyusha_SQL_auto_increment {sgbd} {
    if {$sgbd == "mysql"} {
        set res [list "AUTO_INCREMENT" 0]
    } elseif {$sgbd == "sqlite3" || $sgbd == "sqlite"} {
        set res [list "AUTOINCREMENT" 0]
    } elseif {$sgbd == "sqlserver"} {
        set res [list "IDENTITY\(1,1\)" 0]
    } elseif {$sgbd == "postgres"} {
        set res [list "/* Pour PostgreSQL, utiliser SERIAL à la place de INTEGER pour une incrémentation automatique */" 0]
    } else {
        set res [list "" 0]
    }
    return $res
}

proc Katyusha_SQL_drop_base {base sgbd} {
    set SQL "DROP DATABASE IF EXISTS $base ;\nCREATE DATABASE $base ;"
    if {$sgbd == "mysql"} {
        set SQL "$SQL\nUSE $base ;"
    } elseif {$sgbd == "sqlserver"} {
        set SQL "$SQL\nUSE $base ;"
    } elseif {$sgbd == "postgresql"} {
        set SQL "$SQL\n\\c $base ;"
    } else {
        set SQL ""
    }
    return $SQL
}

proc Katyusha_SQL_ajout_fk {table_lien table_lier nom_attribut nom_origine_attribut} {
    return "ALTER TABLE $table_lien ADD CONSTRAINT FK_$table_lier\_$nom_attribut FOREIGN KEY \($nom_attribut\) REFERENCES $table_lier\($nom_origine_attribut\) ;\n"
}

proc Katyusha_SQL_ajout_colone {table_lien nom_attribut type_attribut} {
    set SQL "ALTER TABLE $table_lien ADD COLUMN $nom_attribut $type_attribut NOT NULL ;\n"
    return $SQL
}
