## Créé le 2/3/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

###############################################################################
#                                                                             #
#                           Interface graphique                               #
#                                                                             #
###############################################################################

# Titre de la fenêtre principale
wm title . "Katyusha MCD"
#wm overrideredirect . 1
wm protocol . WM_DELETE_WINDOW {Katyusha_exit_verif}

wm iconphoto . $IMG_logo

# Taille des canvas
set canvas_x [expr $x - 250]
set canvas_y [expr $y - 150]

# On récupère la taille de l'écran\
set x [winfo screenwidth .]
set y [winfo screenheight .]
#wm geometry . "$x\x$y+0+0"

menu .mb
menu .mb.file -tearoff 0
menu .mb.bdd -tearoff 0
menu .mb.aide -tearoff 0
. configure -menu .mb
.mb add cascade -menu .mb.file -label $LOCALE(menu_fichier)
.mb add cascade -menu .mb.bdd -label $LOCALE(menu_bdd)
.mb add cascade -menu .mb.aide -label $LOCALE(menu_aide)

# Menu Fichier
.mb.file add command -label $LOCALE(menu_sauver_sous) -command Katyusha_sauvegarder_sous
.mb.file add command -label $LOCALE(menu_sauver) -command Katyusha_sauvegarder
.mb.file add command -label $LOCALE(menu_charger) -command Katyusha_charger
.mb.file add command -label $LOCALE(menu_prefs) -command INTERFACE_preferences
.mb.file add command -label $LOCALE(menu_quitter) -command Katyusha_exit_verif

# Menu base de donnée
.mb.bdd add command -label $LOCALE(menu_config_bdd) -command INTERFACE_config_bdd
.mb.bdd add command -label $LOCALE(menu_connex_bdd) -command INTERFACE_connexion_bdd
.mb.bdd add command -label $LOCALE(menu_gen_sql) -command INTERFACE_generation_sql
.mb.bdd add command -label $LOCALE(menu_gen_mcd) -command INTERFACE_generation_mcd

# Menu Aide
.mb.aide add command -label "À propos" -command INTERFACE_apropos

frame .panel
frame .panel.commandes
    # Bouton on/off d'ajout de table
    button .panel.commandes.ajout_table -text $LOCALE(ajouter_table) -image $IMG_ajouter_table -command {Katyusha_action_boutons_ajout "table"}
    # Bouton on/off d'ajout d'une relation
    button .panel.commandes.ajout_relation -text $LOCALE(ajouter_relation) -image $IMG_ajouter_relation -command {Katyusha_action_boutons_ajout "relation"}
    # Bouton on/off d'ajout d'un héritage
    button .panel.commandes.ajout_heritage -text $LOCALE(ajouter_heritage) -image $IMG_ajouter_heritage -command {Katyusha_action_boutons_ajout "heritage"}
    # Bouton on/off d'ajout d'une étiquette
    button .panel.commandes.ajout_etiquette -text $LOCALE(ajouter_etiquette) -image $IMG_ajouter_etiquette -command {Katyusha_action_boutons_ajout "etiquette"}
    pack .panel.commandes.ajout_table .panel.commandes.ajout_relation .panel.commandes.ajout_heritage .panel.commandes.ajout_etiquette -side left
pack .panel.commandes
    #button .panel.ajout_procedure -text $LOCALE(ajouter_procedure) -command INTERFACE_ajout_procedure
    #pack .panel.ajout_procedure -fill x
    label .panel.entites -text $LOCALE(entites_de_la_base) -justify left
    pack .panel.entites -fill x
    canvas .panel.arbre -height [expr $canvas_y - 30] -width 250 -background #F5F5F5
    pack .panel.arbre
pack .panel -side left
frame .mcd
    # Infos de la base de données
    frame .mcd.infos_bdd
        label .mcd.infos_bdd.nom_bdd -text "Nom de la base de données : $BDD(nom)"
        label .mcd.infos_bdd.sgbd -text "SGBD cible : $BDD(sgbd)"
        # Bouton d'édition
        button .mcd.infos_bdd.edit -text "Éditer" -image $IMG_editer -compound right -command INTERFACE_config_bdd
        # Bouton de génération du script SQL pour le SGBD par défaut
        button .mcd.infos_bdd.gen -text "Générer le script SQL pour $BDD(sgbd)" -image $IMG_gen_sql -compound right -command {
            global BDD
            if {[Katyusha_verification_mcd] == 1} {
                set res_info [tk_messageBox -icon warning -type ok -message "Il y a une erreur dans le MCD qui empêche la génération du script SQL pour $BDD(sgbd)"]
            } else {
                set SQL [Katyusha_generation_sql $BDD(sgbd)]
                INTERFACE_script_SQL [lindex $SQL 0] [lindex $SQL 1]
            }
        }
        pack .mcd.infos_bdd.gen .mcd.infos_bdd.edit -fill x -side right
        pack .mcd.infos_bdd.nom_bdd .mcd.infos_bdd.sgbd -fill x -side left -padx 50
    pack .mcd.infos_bdd -fill x
    # Canvas principal
    canvas .mcd.c -background white -height $canvas_y -width $canvas_x
    pack .mcd.c -fill both
    # Position X / Y dur curseur et splash
    frame .mcd.infos
        frame .mcd.infos.s
            label .mcd.infos.s.splash -text $splash -width 100
            label .mcd.infos.s.position_curseur -text "" -width 100
            pack .mcd.infos.s.position_curseur -fill x -padx 10 -side right
            pack .mcd.infos.s.splash -fill x -padx 10 -side left
        pack .mcd.infos.s -fill x
        label .mcd.infos.fichier -text $fichier_sauvegarde
        pack .mcd.infos.fichier -fill x
    pack .mcd.infos
pack .mcd -side left

#while {1==1} {
    set px [.mcd.c canvasx [winfo pointerx .]]
    set py [.mcd.c canvasy [winfo pointery .]]
    .mcd.infos.s.position_curseur configure -text "x : $px / y : $py"
    update
#}

Katyusha_grille
maj_arbre_entites